package eu.mhsl.minenet.minigames.command.privileged;

import eu.mhsl.minenet.minigames.message.Icon;
import eu.mhsl.minenet.minigames.message.type.ActionBarMessage;
import eu.mhsl.minenet.minigames.message.type.ChatMessage;
import eu.mhsl.minenet.minigames.message.type.TitleMessage;
import net.minestom.server.command.builder.Command;

import java.util.ArrayList;
import java.util.List;

public class DebugCommand extends Command {
    public DebugCommand() {
        super("debug");

        setCondition((sender, commandString) -> sender.hasPermission("admin"));

        setDefaultExecutor((sender, args) -> {
            new ChatMessage(Icon.CHAT).appendTranslated("sample").send(sender);
            new ActionBarMessage().appendTranslated("sample").send(sender);
            new TitleMessage().subtitle(subtitleMessage -> subtitleMessage.appendTranslated("sample")).appendTranslated("sample").send(sender);
            List<String> testplayers = new ArrayList<>() {
                {
                    add("MineTec");
                    add("Goldi187");
                    add("Test");
                }
            };
            new ChatMessage(Icon.STAR)
                    .appendTranslated("score#result")
                    .newLine()
                    .appendStatic("Test")
                    .appendStatic("Test")
                    .indent()
                    .list(testplayers)
                    .appendTranslated("score#thanks")
                    .send(sender);
        });

    }
}
