package eu.mhsl.minenet.minigames.command.privileged;

import eu.mhsl.minenet.minigames.message.Icon;
import eu.mhsl.minenet.minigames.message.type.ChatMessage;
import net.minestom.server.MinecraftServer;
import net.minestom.server.command.builder.Command;
import net.minestom.server.command.builder.arguments.ArgumentType;
import net.minestom.server.entity.Player;
import net.minestom.server.permission.Permission;

public class OpCommand extends Command {
    public OpCommand() {
        super("op");

        setCondition((sender, commandString) -> sender.hasPermission("admin"));

        addSyntax((sender, context) -> {
            Player target = MinecraftServer.getConnectionManager().getPlayer(context.getRaw("target"));
            if(target != null)
                target.addPermission(new Permission("admin"));
            else
                new ChatMessage(Icon.ERROR).appendStatic("Spieler nicht gefunden").send(sender);
        }, ArgumentType.Entity("target").onlyPlayers(true));
    }
}
