package eu.mhsl.minenet.minigames.instance.game;

import eu.mhsl.minenet.minigames.instance.game.stateless.config.GameFactory;
import eu.mhsl.minenet.minigames.instance.game.stateless.types.backrooms.BackroomsFactory;
import eu.mhsl.minenet.minigames.instance.game.stateless.types.bedwars.BedwarsFactory;
import eu.mhsl.minenet.minigames.instance.game.stateless.types.deathcube.DeathcubeFactory;
import eu.mhsl.minenet.minigames.instance.game.stateless.types.minerun.MinerunFactory;
import eu.mhsl.minenet.minigames.instance.game.stateless.types.spleef.SpleefFactory;
import eu.mhsl.minenet.minigames.instance.game.stateless.types.stickfight.StickFightFactory;
import eu.mhsl.minenet.minigames.instance.game.stateless.types.towerdefense.TowerdefenseFactory;
import eu.mhsl.minenet.minigames.instance.game.stateless.types.trafficlightrace.TrafficLightRaceFactory;

public enum GameList {
    DEATHCUBE(new DeathcubeFactory(), GameType.OTHER),
    STICKFIGHT(new StickFightFactory(), GameType.PVP),
    MINERUN(new MinerunFactory(), GameType.PVE),
    TRAFFICLIGHTRACE(new TrafficLightRaceFactory(), GameType.OTHER),
    TOWERDEFENSE(new TowerdefenseFactory(), GameType.PVE),
    BEDWARS(new BedwarsFactory(), GameType.PVP),
    BACKROOMS(new BackroomsFactory(), GameType.PVE),
    SPLEEF(new SpleefFactory(), GameType.PVP);

    private final GameFactory factory;
    private final GameType type;
    GameList(GameFactory factory, GameType type) {
        this.factory = factory;
        this.type = type;
    }
    public GameFactory getFactory() {
        return this.factory;
    }

    public GameType getType() {
        return type;
    }
}
