package eu.mhsl.minenet.minigames.message.component;

import eu.mhsl.minenet.minigames.lang.Languages;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.ComponentLike;
import net.kyori.adventure.text.format.NamedTextColor;
import net.minestom.server.entity.Player;
import org.jetbrains.annotations.NotNull;

public class TranslatedComponent implements ComponentLike, Translatable {
    private final String mapId;
    private String result;

    private NamedTextColor color;

    public static TranslatedComponent byId(String mapId) {
        return new TranslatedComponent(mapId);
    }

    public static Component assemble(String mapid, Player p) {
        return new TranslatedComponent(mapid).getAssembled(p);
    }

    private TranslatedComponent(String mapId) {
        this.mapId = mapId;
    }

    public void assemble(Player p) {
        result = Languages.getInstance().getLanguage(p).getEntry(mapId);
    }

    public void assemble(String language) {
        result = Languages.getInstance().getLanguage(language).getEntry(mapId);
    }

    public Component getAssembled(Player p) {
        this.assemble(p);
        return asComponent();
    }

    public TranslatedComponent setColor(NamedTextColor color) {
        this.color = color;
        return this;
    }

    @Override
    public @NotNull Component asComponent() {
        //assemble(Languages.getInstance().getLanguage(Languages.defaultLanguage).getEntry(mapId));
        if(color != null)
            return Component.text(result, color);
        else
            return Component.text(result);
    }
}
