package eu.mhsl.minenet.minigames.score;

import eu.mhsl.minenet.minigames.message.type.TitleMessage;
import net.minestom.server.entity.Player;

import java.time.Duration;
import java.util.ArrayList;
import java.util.List;

public class LastWinsScore extends Score {
    private List<Player> scores = new ArrayList<>();
    private int ignoreLastPlayers = 0;

    public LastWinsScore() {}

    public LastWinsScore(int ignoreLastPlayers) {
        this.ignoreLastPlayers = ignoreLastPlayers;
    }

    public void setIgnoreLastPlayers(int ignoreLastPlayers) {
        this.ignoreLastPlayers = ignoreLastPlayers;
    }

    @Override
    protected void checkGameEnd() {
        if(this.isDone()) return;
        if(instance.getPlayers().isEmpty()) return;
        if(scores.size() >= instance.getPlayers().size() - ignoreLastPlayers) setDone();
    }

    @Override
    public void addResult(Player p) {
        if(scores.contains(p)) return;
        scores.add(0, p);

        new TitleMessage(Duration.ofMillis(1000), Duration.ofSeconds(1)).appendTranslated("score#death").send(p);

        this.checkGameEnd();
    }

    @Override
    protected List<String> getResults() {
        return scores.stream().map(Player::getUsername).toList();
    }
}
