package eu.mhsl.minenet.minigames.score;

import eu.mhsl.minenet.minigames.instance.game.Game;
import eu.mhsl.minenet.minigames.message.Icon;
import eu.mhsl.minenet.minigames.message.type.ChatMessage;
import net.minestom.server.entity.Player;
import net.minestom.server.event.instance.AddEntityToInstanceEvent;
import net.minestom.server.event.instance.RemoveEntityFromInstanceEvent;
import net.minestom.server.event.player.PlayerDisconnectEvent;

import java.util.List;

public abstract class Score {
    private boolean isDone = false;
    protected Game instance;

    public void attachListeners() {
        this.instance.eventNode()
                .addListener(AddEntityToInstanceEvent.class, addEntityToInstanceEvent -> checkGameEnd())
                .addListener(RemoveEntityFromInstanceEvent.class, addEntityToInstanceEvent -> checkGameEnd())
                .addListener(PlayerDisconnectEvent.class, addEntityToInstanceEvent -> checkGameEnd());
    }

    abstract protected void checkGameEnd();
    public abstract void addResult(Player p);
    abstract protected List<String> getResults();

    public boolean isDone() {
        return isDone;
    }

    public void setDone() {
        isDone = true;
        new ChatMessage(Icon.STAR)
                .appendTranslated("score#result")
                .newLine()
                .indent()
                .numberedList(getResults())
                .undent()
                .newLine()
                .appendTranslated("score#thanks")
                .send(instance.getPlayers());

        instance.stop();
    }

    protected void onGameEnd() {
        this.instance.stop();
    }

    public void setInstance(Game instance) {
        this.instance = instance;
    }
}
